<html>
<head>
<title>OGRE: OgreTextureUnitState.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreTextureUnitState.h</h1><a href="OgreTextureUnitState_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __TextureUnitState_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __TextureUnitState_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>"</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreBlendMode_8h.html">OgreBlendMode.h</a>"</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreMatrix4_8h.html">OgreMatrix4.h</a>"</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include "<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>"</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include "<a class="code" href="OgreString_8h.html">OgreString.h</a>"</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include "<a class="code" href="OgreTexture_8h.html">OgreTexture.h</a>"</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="keyword">namespace </span>Ogre {
<a name="l00056"></a><a class="code" href="classOgre_1_1TextureUnitState.html">00056</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique...">TextureUnitState</a>
<a name="l00057"></a>00057     {
<a name="l00058"></a><a class="code" href="classOgre_1_1TextureUnitState.html#06b786d8e0847dfe9cc15e1dea308fcd">00058</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a>;
<a name="l00059"></a>00059     <span class="keyword">public</span>:
<a name="l00065"></a><a class="code" href="classOgre_1_1TextureUnitState.html#717b14961a636b3a18b8ab3dcef61626">00065</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1TextureUnitState.html#717b14961a636b3a18b8ab3dcef61626" title="Definition of the broad types of texture effect you can apply to a texture unit.">TextureEffectType</a>
<a name="l00066"></a>00066         {
<a name="l00068"></a><a class="code" href="classOgre_1_1TextureUnitState.html#717b14961a636b3a18b8ab3dcef616262f0676d96ba378e32c3087fff9b7e73e">00068</a>             ET_ENVIRONMENT_MAP,
<a name="l00070"></a><a class="code" href="classOgre_1_1TextureUnitState.html#717b14961a636b3a18b8ab3dcef61626e6f4dff5b324b7aa28253c37702a5131">00070</a>             ET_PROJECTIVE_TEXTURE,
<a name="l00072"></a><a class="code" href="classOgre_1_1TextureUnitState.html#717b14961a636b3a18b8ab3dcef61626ddf3dd2bc4eeabca2968c71600c347aa">00072</a>             ET_UVSCROLL,
<a name="l00074"></a><a class="code" href="classOgre_1_1TextureUnitState.html#717b14961a636b3a18b8ab3dcef61626b5e67e4d891aad2e60925b216de34f08">00074</a>             ET_USCROLL,
<a name="l00076"></a><a class="code" href="classOgre_1_1TextureUnitState.html#717b14961a636b3a18b8ab3dcef6162697f8687c21d13e08b89d22902919acaa">00076</a>             ET_VSCROLL,
<a name="l00078"></a><a class="code" href="classOgre_1_1TextureUnitState.html#717b14961a636b3a18b8ab3dcef616269afa2c9da615898c1a045e19bb3e602b">00078</a>             ET_ROTATE,
<a name="l00080"></a><a class="code" href="classOgre_1_1TextureUnitState.html#717b14961a636b3a18b8ab3dcef6162697cd551c90f9f6000fe231f542815852">00080</a>             ET_TRANSFORM
<a name="l00081"></a>00081 
<a name="l00082"></a>00082         };
<a name="l00083"></a>00083 
<a name="l00089"></a><a class="code" href="classOgre_1_1TextureUnitState.html#72a88b1cf11053da98fa25f98689931e">00089</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1TextureUnitState.html#72a88b1cf11053da98fa25f98689931e" title="Enumeration to specify type of envmap.">EnvMapType</a>
<a name="l00090"></a>00090         {
<a name="l00092"></a><a class="code" href="classOgre_1_1TextureUnitState.html#72a88b1cf11053da98fa25f98689931e50895f1c891eedb007500965ca4c204a">00092</a>             ENV_PLANAR,
<a name="l00094"></a><a class="code" href="classOgre_1_1TextureUnitState.html#72a88b1cf11053da98fa25f98689931e5a2d57450ada903ba586826344b7dbcb">00094</a>             ENV_CURVED,
<a name="l00096"></a><a class="code" href="classOgre_1_1TextureUnitState.html#72a88b1cf11053da98fa25f98689931e3983cce37fbce61c118d202278166be9">00096</a>             ENV_REFLECTION,
<a name="l00098"></a><a class="code" href="classOgre_1_1TextureUnitState.html#72a88b1cf11053da98fa25f98689931ee1644f418a586fea471d808485a7a036">00098</a>             ENV_NORMAL
<a name="l00099"></a>00099         };
<a name="l00100"></a>00100 
<a name="l00106"></a><a class="code" href="classOgre_1_1TextureUnitState.html#942a1ce66d0909d29ed09c98e9e6d82d">00106</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1TextureUnitState.html#942a1ce66d0909d29ed09c98e9e6d82d" title="Useful enumeration when dealing with procedural transforms.">TextureTransformType</a>
<a name="l00107"></a>00107         {
<a name="l00108"></a><a class="code" href="classOgre_1_1TextureUnitState.html#942a1ce66d0909d29ed09c98e9e6d82d46631ede4b31d448ebb891daf94cd526">00108</a>             TT_TRANSLATE_U,
<a name="l00109"></a><a class="code" href="classOgre_1_1TextureUnitState.html#942a1ce66d0909d29ed09c98e9e6d82d81757d80ac644a8da31f107a9cc21fdc">00109</a>             TT_TRANSLATE_V,
<a name="l00110"></a><a class="code" href="classOgre_1_1TextureUnitState.html#942a1ce66d0909d29ed09c98e9e6d82d7160eae1144aeb0cb6428416e465fd88">00110</a>             TT_SCALE_U,
<a name="l00111"></a><a class="code" href="classOgre_1_1TextureUnitState.html#942a1ce66d0909d29ed09c98e9e6d82d6e85f00afb893c2bace9a394e5ac9f95">00111</a>             TT_SCALE_V,
<a name="l00112"></a><a class="code" href="classOgre_1_1TextureUnitState.html#942a1ce66d0909d29ed09c98e9e6d82decf829c4f898451d496f56e774e0eacf">00112</a>             TT_ROTATE
<a name="l00113"></a>00113         };
<a name="l00114"></a>00114 
<a name="l00120"></a><a class="code" href="classOgre_1_1TextureUnitState.html#47c5a9f4fc08159b99bdc51103bcf852">00120</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1TextureUnitState.html#47c5a9f4fc08159b99bdc51103bcf852" title="Texture addressing modes - default is TAM_WRAP.">TextureAddressingMode</a>
<a name="l00121"></a>00121         {
<a name="l00123"></a><a class="code" href="classOgre_1_1TextureUnitState.html#47c5a9f4fc08159b99bdc51103bcf8529421f7d4fa30994823c3a011ca693a8d">00123</a>             TAM_WRAP,
<a name="l00125"></a><a class="code" href="classOgre_1_1TextureUnitState.html#47c5a9f4fc08159b99bdc51103bcf8522f132fdcdbeea6b30d8cb84f2fc50239">00125</a>             TAM_MIRROR,
<a name="l00127"></a><a class="code" href="classOgre_1_1TextureUnitState.html#47c5a9f4fc08159b99bdc51103bcf85201e4d16b7bc55a9718db2e5a3bf22378">00127</a>             TAM_CLAMP,
<a name="l00129"></a><a class="code" href="classOgre_1_1TextureUnitState.html#47c5a9f4fc08159b99bdc51103bcf8524fe25e95df059a8d54bc3d9cf57986a0">00129</a>             TAM_BORDER
<a name="l00130"></a>00130         };
<a name="l00131"></a>00131 
<a name="l00133"></a><a class="code" href="structOgre_1_1TextureUnitState_1_1UVWAddressingMode.html">00133</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1TextureUnitState_1_1UVWAddressingMode.html" title="Texture addressing mode for each texture coordinate.">UVWAddressingMode</a>
<a name="l00134"></a>00134         {
<a name="l00135"></a><a class="code" href="structOgre_1_1TextureUnitState_1_1UVWAddressingMode.html#17f72c5a85d6b0bf30feb2c0b5b24fd2">00135</a>             <a class="code" href="classOgre_1_1TextureUnitState.html#47c5a9f4fc08159b99bdc51103bcf852" title="Texture addressing modes - default is TAM_WRAP.">TextureAddressingMode</a> u, v, w;
<a name="l00136"></a>00136         };
<a name="l00137"></a>00137 
<a name="l00140"></a><a class="code" href="classOgre_1_1TextureUnitState.html#2584766311cf6d0eaada7be28c287cc3">00140</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1TextureUnitState.html#2584766311cf6d0eaada7be28c287cc3" title="Enum identifying the frame indexes for faces of a cube map (not the composite 3D...">TextureCubeFace</a>
<a name="l00141"></a>00141         {
<a name="l00142"></a><a class="code" href="classOgre_1_1TextureUnitState.html#2584766311cf6d0eaada7be28c287cc3a9d74ce7d0576d0dda5b5046a6434529">00142</a>             CUBE_FRONT = 0,
<a name="l00143"></a><a class="code" href="classOgre_1_1TextureUnitState.html#2584766311cf6d0eaada7be28c287cc34459a171ecd0fe942dc5b5f8e517ecb2">00143</a>             CUBE_BACK = 1,
<a name="l00144"></a><a class="code" href="classOgre_1_1TextureUnitState.html#2584766311cf6d0eaada7be28c287cc32062c3ecab68e4d86345293283f69a19">00144</a>             CUBE_LEFT = 2,
<a name="l00145"></a><a class="code" href="classOgre_1_1TextureUnitState.html#2584766311cf6d0eaada7be28c287cc35044b1ee092361549f2ea953ed344b0a">00145</a>             CUBE_RIGHT = 3,
<a name="l00146"></a><a class="code" href="classOgre_1_1TextureUnitState.html#2584766311cf6d0eaada7be28c287cc3b085d126cff272045a1e616adbd2d726">00146</a>             CUBE_UP = 4,
<a name="l00147"></a><a class="code" href="classOgre_1_1TextureUnitState.html#2584766311cf6d0eaada7be28c287cc3819e8a0cf0892c671d2fb4835780a12a">00147</a>             CUBE_DOWN = 5
<a name="l00148"></a>00148         };
<a name="l00149"></a>00149 
<a name="l00152"></a><a class="code" href="structOgre_1_1TextureUnitState_1_1TextureEffect.html">00152</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1TextureUnitState_1_1TextureEffect.html" title="Internal structure defining a texture effect.">TextureEffect</a> {
<a name="l00153"></a><a class="code" href="structOgre_1_1TextureUnitState_1_1TextureEffect.html#ded68c8d04446c4e9b9616f356be06de">00153</a>             <a class="code" href="classOgre_1_1TextureUnitState.html#717b14961a636b3a18b8ab3dcef61626" title="Definition of the broad types of texture effect you can apply to a texture unit.">TextureEffectType</a> type;
<a name="l00154"></a><a class="code" href="structOgre_1_1TextureUnitState_1_1TextureEffect.html#3436e57eb0e5f928522ef07a93b11e2d">00154</a>             <span class="keywordtype">int</span> subtype;
<a name="l00155"></a><a class="code" href="structOgre_1_1TextureUnitState_1_1TextureEffect.html#91a3e4c00a58f31c59aa1081e62d0b73">00155</a>             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> arg1, arg2;
<a name="l00156"></a><a class="code" href="structOgre_1_1TextureUnitState_1_1TextureEffect.html#4727405325577a8151cd706ef6bef824">00156</a>             <a class="code" href="namespaceOgre.html#bf2e0412a783a6f708ca1a58abb45c1b" title="Enumerates the wave types usable with the Ogre engine.">WaveformType</a> waveType;
<a name="l00157"></a><a class="code" href="structOgre_1_1TextureUnitState_1_1TextureEffect.html#03b721b43c1f02ce9a965c2c8422080e">00157</a>             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> base;
<a name="l00158"></a><a class="code" href="structOgre_1_1TextureUnitState_1_1TextureEffect.html#4612d326766998c6a7ea18a9e1960e4a">00158</a>             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> frequency;
<a name="l00159"></a><a class="code" href="structOgre_1_1TextureUnitState_1_1TextureEffect.html#e1445ba754865180a9472c53bb34e479">00159</a>             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> phase;
<a name="l00160"></a><a class="code" href="structOgre_1_1TextureUnitState_1_1TextureEffect.html#96a6e183d58fede27a9707bd2ab84754">00160</a>             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> amplitude;
<a name="l00161"></a><a class="code" href="structOgre_1_1TextureUnitState_1_1TextureEffect.html#af355fbea2860f3bfcfa05b106ae91b7">00161</a>             <a class="code" href="classOgre_1_1Controller.html" title="Instances of this class &amp;#39;control&amp;#39; the value of another object in the system...">Controller&lt;Real&gt;</a>* controller;
<a name="l00162"></a><a class="code" href="structOgre_1_1TextureUnitState_1_1TextureEffect.html#8f3fe2be82636153864de617fe5f8479">00162</a>             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Frustum.html" title="A frustum represents a pyramid, capped at the near and far end which is used to represent...">Frustum</a>* frustum;
<a name="l00163"></a>00163         };
<a name="l00164"></a>00164 
<a name="l00167"></a><a class="code" href="classOgre_1_1TextureUnitState.html#76b0d087ff12f806b0bd5e8b97d466bf">00167</a>         <span class="keyword">typedef</span> std::multimap&lt;TextureEffectType, TextureEffect&gt; EffectMap;
<a name="l00168"></a>00168 
<a name="l00171"></a>00171         <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique...">TextureUnitState</a>(<a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>* parent);
<a name="l00172"></a>00172 
<a name="l00173"></a>00173         <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique...">TextureUnitState</a>(<a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>* parent, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique...">TextureUnitState</a>&amp; oth );
<a name="l00174"></a>00174 
<a name="l00175"></a>00175         <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique...">TextureUnitState</a> &amp; operator = ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique...">TextureUnitState</a>&amp; oth );
<a name="l00176"></a>00176 
<a name="l00179"></a>00179         ~<a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique...">TextureUnitState</a>();
<a name="l00180"></a>00180 
<a name="l00187"></a>00187         <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique...">TextureUnitState</a>( <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>* parent, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; texName, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> texCoordSet = 0);
<a name="l00188"></a>00188 
<a name="l00197"></a>00197         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getTextureName(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00198"></a>00198 
<a name="l00204"></a>00204         <span class="keywordtype">void</span> setTextureName( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#e50520af6377ff8184cf79125cb9c4d7" title="Enum identifying the texture type.">TextureType</a> ttype = <a class="code" href="namespaceOgre.html#e50520af6377ff8184cf79125cb9c4d7f1f732018f5a2a7d35233e2ceeb4ee0e" title="2D texture, used in combination with 2D texture coordinates (default)">TEX_TYPE_2D</a>);
<a name="l00205"></a>00205 
<a name="l00252"></a>00252         <span class="keywordtype">void</span> setCubicTextureName( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">bool</span> forUVW = <span class="keyword">false</span> );
<a name="l00253"></a>00253 
<a name="l00300"></a>00300         <span class="keywordtype">void</span> setCubicTextureName( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>* <span class="keyword">const</span> names, <span class="keywordtype">bool</span> forUVW = <span class="keyword">false</span> );
<a name="l00301"></a>00301 
<a name="l00323"></a>00323         <span class="keywordtype">void</span> setAnimatedTextureName( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> numFrames, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> duration = 0 );
<a name="l00324"></a>00324 
<a name="l00346"></a>00346         <span class="keywordtype">void</span> setAnimatedTextureName( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>* <span class="keyword">const</span> names, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> numFrames, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> duration = 0 );
<a name="l00347"></a>00347 
<a name="l00350"></a>00350         std::pair&lt; size_t, size_t &gt; getTextureDimensions( <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> frame = 0 ) <span class="keyword">const</span>;
<a name="l00351"></a>00351 
<a name="l00359"></a>00359         <span class="keywordtype">void</span> setCurrentFrame( <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> frameNumber );
<a name="l00360"></a>00360 
<a name="l00365"></a>00365         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> getCurrentFrame(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00366"></a>00366 
<a name="l00372"></a>00372         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getFrameTextureName(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> frameNumber) <span class="keyword">const</span>;
<a name="l00373"></a>00373 
<a name="l00381"></a>00381         <span class="keywordtype">void</span> setFrameTextureName(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> frameNumber);
<a name="l00382"></a>00382 
<a name="l00388"></a>00388         <span class="keywordtype">void</span> addFrameTextureName(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00396"></a>00396         <span class="keywordtype">void</span> deleteFrameTextureName(<span class="keyword">const</span> <span class="keywordtype">size_t</span> frameNumber);
<a name="l00401"></a>00401         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> getNumFrames(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00402"></a>00402 
<a name="l00403"></a>00403 
<a name="l00405"></a><a class="code" href="classOgre_1_1TextureUnitState.html#411bcf3e69280ce146f09ddc73d9e7e8">00405</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1TextureUnitState.html#411bcf3e69280ce146f09ddc73d9e7e8" title="The type of unit to bind the texture settings to.">BindingType</a>
<a name="l00406"></a>00406         {
<a name="l00408"></a><a class="code" href="classOgre_1_1TextureUnitState.html#411bcf3e69280ce146f09ddc73d9e7e839c5f87a9b1c5873ece87f48cba19970">00408</a>             BT_FRAGMENT = 0,
<a name="l00412"></a><a class="code" href="classOgre_1_1TextureUnitState.html#411bcf3e69280ce146f09ddc73d9e7e8857de1fa5e307a5a5b0df779ad4a470e">00412</a>             BT_VERTEX = 1
<a name="l00413"></a>00413         };
<a name="l00416"></a><a class="code" href="classOgre_1_1TextureUnitState.html#35a108a68c71c8267af4af8c1a819030">00416</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1TextureUnitState.html#35a108a68c71c8267af4af8c1a819030" title="Enum identifying the type of content this texture unit contains.">ContentType</a>
<a name="l00417"></a>00417         {
<a name="l00419"></a><a class="code" href="classOgre_1_1TextureUnitState.html#35a108a68c71c8267af4af8c1a8190301bffc0ebc06c072fd00b5e032ba3ce01">00419</a>             CONTENT_NAMED = 0,
<a name="l00421"></a><a class="code" href="classOgre_1_1TextureUnitState.html#35a108a68c71c8267af4af8c1a819030781de9de8d083db90677da1176d8ba82">00421</a>             CONTENT_SHADOW = 1
<a name="l00422"></a>00422         };
<a name="l00423"></a>00423 
<a name="l00433"></a>00433         <span class="keywordtype">void</span> setBindingType(BindingType bt);
<a name="l00434"></a>00434 
<a name="l00437"></a>00437         BindingType getBindingType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00438"></a>00438 
<a name="l00444"></a>00444         <span class="keywordtype">void</span> setContentType(ContentType ct);
<a name="l00446"></a>00446         ContentType getContentType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00447"></a>00447 
<a name="l00454"></a>00454         <span class="keywordtype">bool</span> isCubic(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00455"></a>00455 
<a name="l00460"></a>00460         <span class="keywordtype">bool</span> is3D(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00461"></a>00461 
<a name="l00466"></a>00466         <a class="code" href="namespaceOgre.html#e50520af6377ff8184cf79125cb9c4d7" title="Enum identifying the texture type.">TextureType</a> getTextureType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00467"></a>00467 
<a name="l00470"></a>00470         <span class="keywordtype">void</span> setDesiredFormat(<a class="code" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> desiredFormat);
<a name="l00471"></a>00471 
<a name="l00474"></a>00474         <a class="code" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> getDesiredFormat(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00475"></a>00475 
<a name="l00478"></a>00478         <span class="keywordtype">void</span> setNumMipmaps(<span class="keywordtype">int</span> numMipmaps);
<a name="l00479"></a>00479 
<a name="l00482"></a>00482         <span class="keywordtype">int</span> getNumMipmaps(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00483"></a>00483 
<a name="l00486"></a>00486         <span class="keywordtype">void</span> setIsAlpha(<span class="keywordtype">bool</span> isAlpha);
<a name="l00487"></a>00487 
<a name="l00490"></a>00490         <span class="keywordtype">bool</span> getIsAlpha(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00491"></a>00491 
<a name="l00496"></a>00496         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> getTextureCoordSet(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00497"></a>00497 
<a name="l00505"></a>00505         <span class="keywordtype">void</span> setTextureCoordSet(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keyword">set</span>);
<a name="l00506"></a>00506 
<a name="l00522"></a>00522         <span class="keywordtype">void</span> setTextureTransform(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a>&amp; xform);
<a name="l00523"></a>00523 
<a name="l00531"></a>00531         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a>&amp; getTextureTransform(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00532"></a>00532 
<a name="l00545"></a>00545         <span class="keywordtype">void</span> setTextureScroll(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> u, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> v);
<a name="l00546"></a>00546 
<a name="l00551"></a>00551         <span class="keywordtype">void</span> setTextureUScroll(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> value);
<a name="l00552"></a>00552         <span class="comment">// get texture uscroll value</span>
<a name="l00553"></a>00553         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getTextureUScroll(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00554"></a>00554 
<a name="l00559"></a>00559         <span class="keywordtype">void</span> setTextureVScroll(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> value);
<a name="l00560"></a>00560         <span class="comment">// get texture vscroll value</span>
<a name="l00561"></a>00561         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getTextureVScroll(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00562"></a>00562 
<a name="l00567"></a>00567         <span class="keywordtype">void</span> setTextureUScale(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> value);
<a name="l00568"></a>00568         <span class="comment">// get texture uscale value</span>
<a name="l00569"></a>00569         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getTextureUScale(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00570"></a>00570 
<a name="l00575"></a>00575         <span class="keywordtype">void</span> setTextureVScale(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> value);
<a name="l00576"></a>00576         <span class="comment">// get texture vscale value</span>
<a name="l00577"></a>00577         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getTextureVScale(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00578"></a>00578 
<a name="l00592"></a>00592         <span class="keywordtype">void</span> setTextureScale(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> uScale, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> vScale);
<a name="l00593"></a>00593 
<a name="l00603"></a>00603         <span class="keywordtype">void</span> setTextureRotate(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; angle);
<a name="l00604"></a>00604 <span class="preprocessor">#ifndef OGRE_FORCE_ANGLE_TYPES</span>
<a name="l00605"></a>00605 <span class="preprocessor"></span>        <span class="keyword">inline</span> <span class="keywordtype">void</span> setTextureRotate(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> angle) {
<a name="l00606"></a>00606             setTextureRotate ( <a class="code" href="classOgre_1_1Degree.html" title="Wrapper class which indicates a given angle value is in Degrees.">Degree</a>(angle) );
<a name="l00607"></a>00607         }
<a name="l00608"></a>00608 <span class="preprocessor">#endif//OGRE_FORCE_ANGLE_TYPES</span>
<a name="l00609"></a>00609 <span class="preprocessor"></span>        <span class="comment">// get texture rotation effects angle value</span>
<a name="l00610"></a>00610         <span class="keyword">const</span> Radian&amp; getTextureRotate(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00611"></a>00611 
<a name="l00617"></a>00617         <span class="keyword">const</span> UVWAddressingMode&amp; getTextureAddressingMode(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00618"></a>00618 
<a name="l00628"></a>00628         <span class="keywordtype">void</span> setTextureAddressingMode( TextureAddressingMode tam);
<a name="l00629"></a>00629 
<a name="l00636"></a>00636         <span class="keywordtype">void</span> setTextureAddressingMode( TextureAddressingMode u, 
<a name="l00637"></a>00637             TextureAddressingMode v, TextureAddressingMode w);
<a name="l00638"></a>00638 
<a name="l00645"></a>00645         <span class="keywordtype">void</span> setTextureAddressingMode( <span class="keyword">const</span> UVWAddressingMode&amp; uvw);
<a name="l00646"></a>00646 
<a name="l00654"></a>00654         <span class="keywordtype">void</span> setTextureBorderColour(<span class="keyword">const</span> ColourValue&amp; colour);
<a name="l00655"></a>00655 
<a name="l00661"></a>00661         <span class="keyword">const</span> ColourValue&amp; getTextureBorderColour(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00662"></a>00662 
<a name="l00727"></a>00727         <span class="keywordtype">void</span> setColourOperationEx(
<a name="l00728"></a>00728             <a class="code" href="namespaceOgre.html#264ecab38a04d01e2c3158fa05ec1ee2" title="Expert list of valid texture blending operations, for use with TextureUnitState::setColourOperationE...">LayerBlendOperationEx</a> op,
<a name="l00729"></a>00729             <a class="code" href="namespaceOgre.html#e2ad78de344f35307ce35157c175625e" title="List of valid sources of values for blending operations used in TextureUnitState::setColourOperation...">LayerBlendSource</a> source1 = <a class="code" href="namespaceOgre.html#e2ad78de344f35307ce35157c175625e45f1a14042993f460992b3253ce6ae80" title="the colour derived from the texture assigned to this layer">LBS_TEXTURE</a>,
<a name="l00730"></a>00730             <a class="code" href="namespaceOgre.html#e2ad78de344f35307ce35157c175625e" title="List of valid sources of values for blending operations used in TextureUnitState::setColourOperation...">LayerBlendSource</a> source2 = <a class="code" href="namespaceOgre.html#e2ad78de344f35307ce35157c175625e370f25da69381c74ca1fc51fde81e659" title="the colour as built up from previous stages">LBS_CURRENT</a>,
<a name="l00731"></a>00731 
<a name="l00732"></a>00732             <span class="keyword">const</span> ColourValue&amp; arg1 = <a class="code" href="classOgre_1_1ColourValue.html#8eba66b2908f44f00f8d9c9ec25877de">ColourValue::White</a>,
<a name="l00733"></a>00733             <span class="keyword">const</span> ColourValue&amp; arg2 = <a class="code" href="classOgre_1_1ColourValue.html#8eba66b2908f44f00f8d9c9ec25877de">ColourValue::White</a>,
<a name="l00734"></a>00734 
<a name="l00735"></a>00735             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> manualBlend = 0.0);
<a name="l00736"></a>00736 
<a name="l00755"></a>00755         <span class="keywordtype">void</span> setColourOperation( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#bcbb38d1ac195e4be401f85b7ab0da8f" title="List of valid texture blending operations, for use with TextureUnitState::setColourOperation...">LayerBlendOperation</a> op);
<a name="l00756"></a>00756 
<a name="l00776"></a>00776         <span class="keywordtype">void</span> setColourOpMultipassFallback( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> sourceFactor, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> destFactor);
<a name="l00777"></a>00777 
<a name="l00780"></a>00780         <span class="keyword">const</span> LayerBlendModeEx&amp; getColourBlendMode(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00781"></a>00781 
<a name="l00784"></a>00784         <span class="keyword">const</span> LayerBlendModeEx&amp; getAlphaBlendMode(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00785"></a>00785 
<a name="l00788"></a>00788         <a class="code" href="namespaceOgre.html#41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> getColourBlendFallbackSrc(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00789"></a>00789 
<a name="l00792"></a>00792         <a class="code" href="namespaceOgre.html#41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> getColourBlendFallbackDest(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00793"></a>00793 
<a name="l00819"></a>00819         <span class="keywordtype">void</span> setAlphaOperation(<a class="code" href="namespaceOgre.html#264ecab38a04d01e2c3158fa05ec1ee2" title="Expert list of valid texture blending operations, for use with TextureUnitState::setColourOperationE...">LayerBlendOperationEx</a> op,
<a name="l00820"></a>00820             <a class="code" href="namespaceOgre.html#e2ad78de344f35307ce35157c175625e" title="List of valid sources of values for blending operations used in TextureUnitState::setColourOperation...">LayerBlendSource</a> source1 = <a class="code" href="namespaceOgre.html#e2ad78de344f35307ce35157c175625e45f1a14042993f460992b3253ce6ae80" title="the colour derived from the texture assigned to this layer">LBS_TEXTURE</a>,
<a name="l00821"></a>00821             <a class="code" href="namespaceOgre.html#e2ad78de344f35307ce35157c175625e" title="List of valid sources of values for blending operations used in TextureUnitState::setColourOperation...">LayerBlendSource</a> source2 = <a class="code" href="namespaceOgre.html#e2ad78de344f35307ce35157c175625e370f25da69381c74ca1fc51fde81e659" title="the colour as built up from previous stages">LBS_CURRENT</a>,
<a name="l00822"></a>00822             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> arg1 = 1.0,
<a name="l00823"></a>00823             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> arg2 = 1.0,
<a name="l00824"></a>00824             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> manualBlend = 0.0);
<a name="l00825"></a>00825 
<a name="l00837"></a>00837         <span class="keywordtype">void</span> addEffect(TextureEffect&amp; effect);
<a name="l00838"></a>00838 
<a name="l00866"></a>00866         <span class="keywordtype">void</span> setEnvironmentMap(<span class="keywordtype">bool</span> enable, EnvMapType envMapType = ENV_CURVED);
<a name="l00867"></a>00867 
<a name="l00878"></a>00878         <span class="keywordtype">void</span> setScrollAnimation(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> uSpeed, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> vSpeed);
<a name="l00879"></a>00879 
<a name="l00888"></a>00888         <span class="keywordtype">void</span> setRotateAnimation(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> speed);
<a name="l00889"></a>00889 
<a name="l00909"></a>00909         <span class="keywordtype">void</span> setTransformAnimation( <span class="keyword">const</span> TextureTransformType ttype,
<a name="l00910"></a>00910             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#bf2e0412a783a6f708ca1a58abb45c1b" title="Enumerates the wave types usable with the Ogre engine.">WaveformType</a> waveType, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> base = 0, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> frequency = 1, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> phase = 0, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> amplitude = 1 );
<a name="l00911"></a>00911 
<a name="l00912"></a>00912 
<a name="l00931"></a>00931         <span class="keywordtype">void</span> setProjectiveTexturing(<span class="keywordtype">bool</span> enabled, <span class="keyword">const</span> Frustum* projectionSettings = 0);
<a name="l00932"></a>00932 
<a name="l00935"></a>00935         <span class="keywordtype">void</span> removeAllEffects(<span class="keywordtype">void</span>);
<a name="l00936"></a>00936 
<a name="l00942"></a>00942         <span class="keywordtype">void</span> removeEffect( <span class="keyword">const</span> TextureEffectType type );
<a name="l00943"></a>00943 
<a name="l00949"></a>00949         <span class="keywordtype">bool</span> isBlank(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00950"></a>00950 
<a name="l00953"></a>00953         <span class="keywordtype">void</span> setBlank(<span class="keywordtype">void</span>);
<a name="l00954"></a>00954 
<a name="l00957"></a><a class="code" href="classOgre_1_1TextureUnitState.html#8d90872718c80548803b2d50a0b0db0f">00957</a>         <span class="keywordtype">bool</span> isTextureLoadFailing()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mTextureLoadFailed; }
<a name="l00958"></a>00958 
<a name="l00961"></a><a class="code" href="classOgre_1_1TextureUnitState.html#35ba5dfc7d336a92a1a3eccd260293eb">00961</a>         <span class="keywordtype">void</span> retryTextureLoad() { mTextureLoadFailed = <span class="keyword">false</span>; }
<a name="l00962"></a>00962 
<a name="l00963"></a>00963         <span class="comment">// get texture effects in a multimap paired array</span>
<a name="l00964"></a>00964         <span class="keyword">const</span> EffectMap&amp; getEffects(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00965"></a>00965         <span class="comment">// get the animated-texture animation duration</span>
<a name="l00966"></a>00966         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getAnimationDuration(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00967"></a>00967 
<a name="l00977"></a>00977         <span class="keywordtype">void</span> setTextureFiltering(<a class="code" href="namespaceOgre.html#21a0186392e9c9ce16d29c5568a773c5" title="High-level filtering options providing shortcuts to settings the minification, magnification...">TextureFilterOptions</a> filterType);
<a name="l00982"></a>00982         <span class="keywordtype">void</span> setTextureFiltering(<a class="code" href="namespaceOgre.html#c1fc36ec2f4df4b2afa9fa39f9c66c06">FilterType</a> ftype, <a class="code" href="namespaceOgre.html#02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a> opts);
<a name="l00991"></a>00991         <span class="keywordtype">void</span> setTextureFiltering(<a class="code" href="namespaceOgre.html#02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a> minFilter, <a class="code" href="namespaceOgre.html#02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a> magFilter, <a class="code" href="namespaceOgre.html#02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a> mipFilter);
<a name="l00992"></a>00992         <span class="comment">// get the texture filtering for the given type</span>
<a name="l00993"></a>00993         <a class="code" href="namespaceOgre.html#02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a> getTextureFiltering(<a class="code" href="namespaceOgre.html#c1fc36ec2f4df4b2afa9fa39f9c66c06">FilterType</a> ftpye) <span class="keyword">const</span>;
<a name="l00994"></a>00994 
<a name="l01000"></a>01000         <span class="keywordtype">void</span> setTextureAnisotropy(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> maxAniso);
<a name="l01001"></a>01001         <span class="comment">// get this layer texture anisotropy level</span>
<a name="l01002"></a>01002         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> getTextureAnisotropy() <span class="keyword">const</span>;
<a name="l01003"></a>01003 
<a name="l01016"></a><a class="code" href="classOgre_1_1TextureUnitState.html#cfe54cc0ec2c1247a90094d004d77db1">01016</a>         <span class="keywordtype">void</span> setTextureMipmapBias(<span class="keywordtype">float</span> bias) { mMipmapBias = bias; }
<a name="l01020"></a><a class="code" href="classOgre_1_1TextureUnitState.html#6ae07dacb0695b4cd5bf86d9930ef693">01020</a>         <span class="keywordtype">float</span> getTextureMipmapBias(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mMipmapBias; }
<a name="l01021"></a>01021 
<a name="l01023"></a><a class="code" href="classOgre_1_1TextureUnitState.html#325c1f726b6757635c6de6d2b2db497c">01023</a>         <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>* getParent(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mParent; }
<a name="l01024"></a>01024 
<a name="l01026"></a>01026         <span class="keywordtype">void</span> _load(<span class="keywordtype">void</span>);
<a name="l01028"></a>01028         <span class="keywordtype">void</span> _unload(<span class="keywordtype">void</span>);
<a name="l01030"></a>01030         <span class="keywordtype">bool</span> hasViewRelativeTextureCoordinateGeneration(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l01031"></a>01031 
<a name="l01032"></a>01032         <span class="comment">// Is this loaded?</span>
<a name="l01033"></a>01033         <span class="keywordtype">bool</span> isLoaded(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l01035"></a>01035         <span class="keywordtype">void</span> _notifyNeedsRecompile(<span class="keywordtype">void</span>);
<a name="l01036"></a>01036 
<a name="l01042"></a>01042         <span class="keywordtype">void</span> setName(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l01044"></a><a class="code" href="classOgre_1_1TextureUnitState.html#dadef9033bfc0e3e0f657467a69df413">01044</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getName(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mName; }
<a name="l01045"></a>01045 
<a name="l01049"></a>01049         <span class="keywordtype">void</span> setTextureNameAlias(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l01052"></a><a class="code" href="classOgre_1_1TextureUnitState.html#91157035b59a30a26941c714348d9940">01052</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getTextureNameAlias(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mTextureNameAlias;}
<a name="l01053"></a>01053 
<a name="l01068"></a>01068         <span class="keywordtype">bool</span> applyTextureAliases(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#5dafc9e68bde8099ec5ad6c94e4cf19b" title="Alias / Texture name pair (first = alias, second = texture name).">AliasTextureNamePairList</a>&amp; aliasList, <span class="keyword">const</span> <span class="keywordtype">bool</span> apply = <span class="keyword">true</span>);
<a name="l01069"></a>01069 
<a name="l01071"></a>01071         <span class="keywordtype">void</span> _notifyParent(<a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>* parent);
<a name="l01072"></a>01072 
<a name="l01074"></a>01074         <span class="keyword">const</span> <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a>&amp; _getTexturePtr(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l01076"></a>01076         <span class="keyword">const</span> <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a>&amp; _getTexturePtr(<span class="keywordtype">size_t</span> frame) <span class="keyword">const</span>;
<a name="l01077"></a>01077     
<a name="l01079"></a>01079         <span class="keywordtype">void</span> _setTexturePtr(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a>&amp; texptr);
<a name="l01081"></a>01081         <span class="keywordtype">void</span> _setTexturePtr(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a>&amp; texptr, <span class="keywordtype">size_t</span> frame);
<a name="l01082"></a>01082 
<a name="l01086"></a><a class="code" href="classOgre_1_1TextureUnitState.html#64b0c99b0a3f9c756643760c57833b2d">01086</a>         <a class="code" href="classOgre_1_1Controller.html" title="Instances of this class &amp;#39;control&amp;#39; the value of another object in the system...">Controller&lt;Real&gt;</a>* _getAnimController()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mAnimController; }
<a name="l01087"></a>01087 <span class="keyword">protected</span>:
<a name="l01088"></a>01088         <span class="comment">// State</span>
<a name="l01090"></a><a class="code" href="classOgre_1_1TextureUnitState.html#02c7c1e3b0b496b5a2104b615e35cc7c">01090</a> <span class="comment"></span>        <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> mCurrentFrame;
<a name="l01091"></a>01091 
<a name="l01093"></a><a class="code" href="classOgre_1_1TextureUnitState.html#d0f7fc91e92d142a4e68284600fe7e15">01093</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mAnimDuration;            
<a name="l01094"></a><a class="code" href="classOgre_1_1TextureUnitState.html#1feca5150a0892fdcfef56798e495abb">01094</a>         <span class="keywordtype">bool</span> mCubic; <span class="comment">// is this a series of 6 2D textures to make up a cube?</span>
<a name="l01095"></a>01095         
<a name="l01096"></a><a class="code" href="classOgre_1_1TextureUnitState.html#677d07dd4cd3562667bb734abbfb341d">01096</a>         <a class="code" href="namespaceOgre.html#e50520af6377ff8184cf79125cb9c4d7" title="Enum identifying the texture type.">TextureType</a> mTextureType; 
<a name="l01097"></a><a class="code" href="classOgre_1_1TextureUnitState.html#56d7162ad10f089ec8b2c3a6eb46c86a">01097</a>         <a class="code" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> mDesiredFormat;
<a name="l01098"></a><a class="code" href="classOgre_1_1TextureUnitState.html#5c3baa130f3ae269744d9fe381d11c38">01098</a>         <span class="keywordtype">int</span> mTextureSrcMipmaps; <span class="comment">// Request number of mipmaps</span>
<a name="l01099"></a>01099 
<a name="l01100"></a><a class="code" href="classOgre_1_1TextureUnitState.html#0f825abfffce07c85d14a1f3e146c9a9">01100</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> mTextureCoordSetIndex;
<a name="l01101"></a><a class="code" href="classOgre_1_1TextureUnitState.html#7b12601e083ad571000e0cffd5afc1d9">01101</a>         <a class="code" href="structOgre_1_1TextureUnitState_1_1UVWAddressingMode.html" title="Texture addressing mode for each texture coordinate.">UVWAddressingMode</a> mAddressMode;
<a name="l01102"></a><a class="code" href="classOgre_1_1TextureUnitState.html#0eb57ea895d62837a30b2c954a25126d">01102</a>         <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> mBorderColour;
<a name="l01103"></a>01103 
<a name="l01104"></a><a class="code" href="classOgre_1_1TextureUnitState.html#cde3dab80bb18a1e9c207c863dc262ff">01104</a>         <a class="code" href="classOgre_1_1LayerBlendModeEx.html" title="Class which manages blending of both colour and alpha components.">LayerBlendModeEx</a> mColourBlendMode;
<a name="l01105"></a><a class="code" href="classOgre_1_1TextureUnitState.html#b40a54bcaea6267ff0ca718fd4a5fdd2">01105</a>         <a class="code" href="namespaceOgre.html#41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> mColourBlendFallbackSrc;
<a name="l01106"></a><a class="code" href="classOgre_1_1TextureUnitState.html#34dcbc16f2874661170fd0032ce645b3">01106</a>         <a class="code" href="namespaceOgre.html#41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> mColourBlendFallbackDest;
<a name="l01107"></a>01107 
<a name="l01108"></a><a class="code" href="classOgre_1_1TextureUnitState.html#3a4e9259b5176ce14b6218534f0b1a98">01108</a>         <a class="code" href="classOgre_1_1LayerBlendModeEx.html" title="Class which manages blending of both colour and alpha components.">LayerBlendModeEx</a> mAlphaBlendMode;
<a name="l01109"></a><a class="code" href="classOgre_1_1TextureUnitState.html#4aaf331d8eafccaafad55e5a9d682a12">01109</a>         <span class="keyword">mutable</span> <span class="keywordtype">bool</span> mTextureLoadFailed;
<a name="l01110"></a><a class="code" href="classOgre_1_1TextureUnitState.html#46856b75170d8b7e5f1eaf6a9b75ef40">01110</a>         <span class="keywordtype">bool</span> mIsAlpha;
<a name="l01111"></a>01111 
<a name="l01112"></a><a class="code" href="classOgre_1_1TextureUnitState.html#c6a71eefb751eaa7b147b933a6f03eb4">01112</a>         <span class="keyword">mutable</span> <span class="keywordtype">bool</span> mRecalcTexMatrix;
<a name="l01113"></a><a class="code" href="classOgre_1_1TextureUnitState.html#dbb7dff7456737a962a188a666694534">01113</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mUMod, mVMod;
<a name="l01114"></a><a class="code" href="classOgre_1_1TextureUnitState.html#09ccefafa9be317c4b3abec8234132d6">01114</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mUScale, mVScale;
<a name="l01115"></a><a class="code" href="classOgre_1_1TextureUnitState.html#f00c72d4b2f5f52dc453ad99fe864428">01115</a>         <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a> mRotate;
<a name="l01116"></a><a class="code" href="classOgre_1_1TextureUnitState.html#451f6a41865f4fe17c30465c4df2c174">01116</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a> mTexModMatrix;
<a name="l01117"></a>01117 
<a name="l01119"></a><a class="code" href="classOgre_1_1TextureUnitState.html#9aa242fe4a0ea13a48381d31b849f78b">01119</a>         <a class="code" href="namespaceOgre.html#02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a> mMinFilter;
<a name="l01121"></a><a class="code" href="classOgre_1_1TextureUnitState.html#aea7aaece5d1aa316598b30638afb6c8">01121</a>         <a class="code" href="namespaceOgre.html#02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a> mMagFilter;
<a name="l01123"></a><a class="code" href="classOgre_1_1TextureUnitState.html#75ce7828e7abfd21c5bee0eac8de121e">01123</a>         <a class="code" href="namespaceOgre.html#02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a> mMipFilter;
<a name="l01125"></a><a class="code" href="classOgre_1_1TextureUnitState.html#8f18154fdf1215a3e92347b9b903797e">01125</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> mMaxAniso;
<a name="l01127"></a><a class="code" href="classOgre_1_1TextureUnitState.html#5190ada8aa5e3bd0280838f7f845da52">01127</a>         <span class="keywordtype">float</span> mMipmapBias;
<a name="l01128"></a>01128 
<a name="l01129"></a><a class="code" href="classOgre_1_1TextureUnitState.html#70d87ad455ba800eda429a6b88ca3970">01129</a>         <span class="keywordtype">bool</span> mIsDefaultAniso;
<a name="l01130"></a><a class="code" href="classOgre_1_1TextureUnitState.html#ac714e0b0ba7e099653ffc05ba1f54e4">01130</a>         <span class="keywordtype">bool</span> mIsDefaultFiltering;
<a name="l01132"></a><a class="code" href="classOgre_1_1TextureUnitState.html#1a5e68549284202630b394270fbe6345">01132</a>         <a class="code" href="classOgre_1_1TextureUnitState.html#411bcf3e69280ce146f09ddc73d9e7e8" title="The type of unit to bind the texture settings to.">BindingType</a> mBindingType;
<a name="l01134"></a><a class="code" href="classOgre_1_1TextureUnitState.html#b0d0d1b22588fdfc80021a5ea664ce28">01134</a>         <a class="code" href="classOgre_1_1TextureUnitState.html#35a108a68c71c8267af4af8c1a819030" title="Enum identifying the type of content this texture unit contains.">ContentType</a> mContentType;
<a name="l01135"></a>01135 
<a name="l01136"></a>01136         <span class="comment">//-----------------------------------------------------------------------------</span>
<a name="l01137"></a>01137         <span class="comment">// Complex members (those that can't be copied using memcpy) are at the end to </span>
<a name="l01138"></a>01138         <span class="comment">// allow for fast copying of the basic members.</span>
<a name="l01139"></a>01139         <span class="comment">//</span>
<a name="l01140"></a><a class="code" href="classOgre_1_1TextureUnitState.html#2c70c3128f22e9776c54c03ba5de7bcc">01140</a>         std::vector&lt;String&gt; mFrames;
<a name="l01141"></a><a class="code" href="classOgre_1_1TextureUnitState.html#b0dbceb8adb15dccfcbaade33b4f72d4">01141</a>         <span class="keyword">mutable</span> std::vector&lt;TexturePtr&gt; mFramePtrs;
<a name="l01142"></a><a class="code" href="classOgre_1_1TextureUnitState.html#5720899cf50fe9a083b279db79a977d9">01142</a>         <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> mName;               <span class="comment">// optional name for the TUS</span>
<a name="l01143"></a><a class="code" href="classOgre_1_1TextureUnitState.html#3f509724926adbf8f088ad609a447bd1">01143</a>         <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> mTextureNameAlias;       <span class="comment">// optional alias for texture frames</span>
<a name="l01144"></a><a class="code" href="classOgre_1_1TextureUnitState.html#a9886890d8f908e93aa49ee2f6737686">01144</a>         EffectMap mEffects;
<a name="l01145"></a>01145         <span class="comment">//-----------------------------------------------------------------------------</span>
<a name="l01146"></a>01146 
<a name="l01147"></a>01147         <span class="comment">//-----------------------------------------------------------------------------</span>
<a name="l01148"></a>01148         <span class="comment">// Pointer members (those that can't be copied using memcpy), and MUST</span>
<a name="l01149"></a>01149         <span class="comment">// preserving even if assign from others</span>
<a name="l01150"></a>01150         <span class="comment">//</span>
<a name="l01151"></a><a class="code" href="classOgre_1_1TextureUnitState.html#758554904569551f94a00c8658d2e03d">01151</a>         <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>* mParent;
<a name="l01152"></a><a class="code" href="classOgre_1_1TextureUnitState.html#acf0a13bef6f6ceccc4414c637cbe536">01152</a>         <a class="code" href="classOgre_1_1Controller.html" title="Instances of this class &amp;#39;control&amp;#39; the value of another object in the system...">Controller&lt;Real&gt;</a>* mAnimController;
<a name="l01153"></a>01153         <span class="comment">//-----------------------------------------------------------------------------</span>
<a name="l01154"></a>01154 
<a name="l01155"></a>01155 
<a name="l01158"></a>01158         <span class="keywordtype">void</span> recalcTextureMatrix(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l01159"></a>01159 
<a name="l01162"></a>01162         <span class="keywordtype">void</span> createAnimController(<span class="keywordtype">void</span>);
<a name="l01163"></a>01163 
<a name="l01166"></a>01166         <span class="keywordtype">void</span> createEffectController(<a class="code" href="structOgre_1_1TextureUnitState_1_1TextureEffect.html" title="Internal structure defining a texture effect.">TextureEffect</a>&amp; effect);
<a name="l01167"></a>01167 
<a name="l01169"></a>01169         <span class="keywordtype">void</span> ensureLoaded(<span class="keywordtype">size_t</span> frame) <span class="keyword">const</span>;
<a name="l01170"></a>01170 
<a name="l01171"></a>01171 
<a name="l01172"></a>01172     };
<a name="l01173"></a>01173 
<a name="l01174"></a>01174 
<a name="l01175"></a>01175 }
<a name="l01176"></a>01176 
<a name="l01177"></a>01177 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:57 2008
</p>
</body>
</html>
